<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Other Node Features</TITLE>
<link href="suif1_14.html" rel=Next>
<link href="suif1_12.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_12.html">previous</A>, <A HREF="suif1_14.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC13" HREF="suif1_toc.html#TOC13">Other Features Shared by All Tree Nodes</A></H3>

<P>
<A NAME="IDX39"></A>
<A NAME="IDX40"></A>
The <CODE>tree_node</CODE> class includes several methods to make it more
convenient to retrieve information that is not directly stored in a
node.  The <CODE>scope</CODE> method returns the symbol table for the closest
enclosing scope at a tree node.  The <CODE>proc</CODE> method ascends to the
root of the AST to find the symbol for the procedure containing the tree
node.  Of course, that only works if the node is properly attached to an
AST that is connected to a particular procedure symbol.

</P>
<P>
<A NAME="IDX41"></A>
Textual representations of tree nodes can easily be printed out to files
using the <CODE>print</CODE> method.  The optional <CODE>depth</CODE> parameter
specifies the indentation level for the output.  The output formats for
most kinds of tree nodes are shown in subsequent sections.  For
instruction nodes, the SUIF instructions are printed directly.

</P>
<P>
<A NAME="IDX42"></A>
All tree nodes, except for <CODE>tree_proc</CODE> nodes, are stored on tree
node lists.  Each tree node has a back-pointer to the list that contains
it.  The <CODE>parent</CODE> method is used to access this list pointer.  The
parent of a <CODE>tree_proc</CODE> is always <CODE>NULL</CODE>.  The parent list
pointers are set automatically when tree nodes are added to lists, so
you do not have to deal with maintaining these yourself.

</P>
<P>
<A NAME="IDX43"></A>
Like the other lists in SUIF (see section <A HREF="suif1_92.html#SEC92">Generic Lists</A>), tree node lists
are made up of list elements.  Each of these list elements contains a
pointer to a particular tree node.  Because many of the list methods
operate on the list elements rather than the tree nodes, one often needs
to know the element containing a tree node.  Thus the tree nodes contain
back-pointers to the list elements, which can be accessed with the
<CODE>list_e</CODE> method.  Like the parent pointer, the list element pointer
is automatically set when a tree node is entered in a list.

</P>
<P>
For example, the list elements are needed for inserting nodes before or
after other nodes in a list and for removing nodes from their lists.
The following code inserts the tree node <CODE>new_node</CODE> before the tree
node <CODE>cur_node</CODE> and then removes <CODE>cur_node</CODE> from the list:

</P>

<PRE>
tree_node_list *tnl = cur_node-&#62;parent(); 
tnl-&#62;insert_before(new_node, cur_node-&#62;list_e());
tree_node_list_e *elem = tnl-&#62;remove(cur_node-&#62;list_e());
</PRE>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_12.html">previous</A>, <A HREF="suif1_14.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
